CON
  points = 1200

PUB start (pointsArrayPtr)
  cognew(@asm_entry,pointsArrayPtr)
'if you comment out the time stuff you should get around 2 to 3 MHz output
'which at 16 bits is 4 to 6 MB/s  
DAT

              org 0
'init with start and end address for values
asm_entry     rdword ptrStart, par  'get the start of the frame by reading start pointer
              mov end, ptrStart     'get the address of the end of the points
              add end, length       'by copying the start address and adding the number of points in it
              mov current, ptrStart 'set the current pointer to the start
              mov dira, dira_setup
              mov time, cnt
               
'compare address to end
:loop         cmp current, end  wz
              'mov time, cnt
              add time, #511         'don't really need this

'Read 16 bit value from hub and output it
              rdword outa, current
        
'set to start if equal
        if_e  jmp #asm_entry

'add one if  not equal
        if_ne add current, #2
              waitcnt time, #511     'don't really need this         
'loop
              jmp #:loop
'timer clock-128MHz??   'some old calculations that don't apply anymore
'2_000 points per frame * 80 frames per second = 160_000 points per second
'80/.16=500 clock cycles per point
'500/4=125 instructions per point

'
'
'Data
'
'
'period        long 500 ' should be 500     'no longer used
length        long (points-1)*2     'the number of points to display
dira_setup    long 65535         'how to setup the output pins
end           res 1              'address of the end of the points
current       res 1              'where we are currently getting values from
ptrStart      res 1              'where we start to get points from
time          res 1              'don't really need this